> For the complete documentation index, see [llms.txt](https://docs.coda.co/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.coda.co/codapay/codapay-integration-faq/direct-card-api.md).

# Direct Card API

#### 1. **Do we need to add our server IPs to Coda’s whitelist when using the Direct Card Integration APIs?**

No, IP whitelisting is not required for either the production or sandbox environment.

***

#### **2. What value should be used for the `payment_method.card.country_code` field in the submit charge endpoint?**

The value should match the country of the Account ID being used. For example, if you are requesting in Saudi Arabia, the country code should be set to `SA`.

***

#### **3. Can failed 3DS authentication be simulated in the sandbox environment?**

Currently, the sandbox environment does not support simulating failed 3DS challenges. Regardless of the input on the 3DS page, the transaction will be marked as successful.

***

#### **4. Does the `amount_currency` field only support local currencies?**

The `amount_currency` field supports both local currencies (LCY) and USD.

***

#### **5. How should the `amount_value` field be specified?**

The `amount_value` field uses the literal value, not the smallest unit based on ISO 4217.\
For example, to represent 1.00 USD, set `amount_value` as `"1.00"` (not `"100"`), and for 1 JPY, use `"1"`.

***

#### **6. Is there a length limit for the `partner_reference` field?**

Yes, the `partner_reference` field must be between 4 and 64 characters in length. If this limit is exceeded or not met, the system will return a `400 Bad Request` error.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.coda.co/codapay/codapay-integration-faq/direct-card-api.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
